#include "maze.h"

using namespace std;

const char Maze::Wall = '#';
const char Maze::Start = 's';
const char Maze::Goal = 'g';

Maze::Maze()
    : theWidth(0), theHeight(0)
{
}

void Maze::set(unsigned x, unsigned y, char c)
{
    rooms[y][x] = c;
}

char Maze::operator()(unsigned x, unsigned y) const
{
    if (x >= theWidth || y >= theHeight)
        return Wall;
    else
        return rooms[y][x];
}


Point Maze::goalPosition() const
{
    for (unsigned y = 0; y < theHeight; ++y)
    {
        string::size_type x = rooms[y].find(Goal);
        if (x != string::npos)
        {
            return Point {(unsigned)x, y};
        }
    }
    return Point {0, 0};
}

Point Maze::startPosition() const
{
    for (unsigned y = 0; y < theHeight; ++y)
    {
        string::size_type x = rooms[y].find(Start);
        if (x != string::npos)
        {
            return Point {(unsigned)x, y};
        }
    }
    return Point {0, 0};
}



std::istream& operator>> (std::istream& in, Maze& m)
{
    in >> m.theWidth >> m.theHeight;
    string line;
    getline(in, line);
    for (unsigned i = 0; i < m.height(); ++i)
    {
        getline(in, line);
        while (line.size() < m.width())
            line += Maze::Wall;
        if (line.size() > m.width())
            line = line.substr(0, m.width());
        m.rooms.push_back(line);
    }
    return in;
}

std::ostream& operator<< (std::ostream& out, const Maze& m)
{
    for (const string& row: m.rooms)
    {
        out << row << "\n";
    }
    return out;
}
