#ifndef MAZE_H
#define MAZE_H

#include <iostream>
#include <string>
#include <vector>

#include "point.h"

class Maze {
public:
    static const char Wall; // = '#';
    static const char Start; // = 's';
    static const char Goal; // = 'g';

    Maze();

    unsigned width() const {return theWidth;}
    unsigned height() const {return theHeight;}

    void set(unsigned x, unsigned y, char c);
    char operator() (unsigned x, unsigned y) const;

    Point goalPosition() const;
    Point startPosition() const;
    
private:
    unsigned theWidth;
    unsigned theHeight;
    std::vector<std::string> rooms;

    friend std::istream& operator>> (std::istream& in, Maze& m);
    friend std::ostream& operator<< (std::ostream& out, const Maze& m);

};

std::istream& operator>> (std::istream& in, Maze& m);
std::ostream& operator<< (std::ostream& out, const Maze& m);


#endif

