#include "maze.h"
#include "point.h"
#include <iostream>
#include <fstream>
#include <queue>
#include <stack>

using namespace std;

void trickleInto (unsigned x, unsigned y, stack<Point>& q,
		Maze& maze, int dist)
{
	if (maze(x,y) == ' ' || maze(x,y) == Maze::Goal)
	{
		// mark (x,y) in maze as distance dist+1
		int newDist = '@' + dist + 1;
		maze.set(x, y, newDist);
		q.push(Point({x,y}));
	}
}


int findShortestPath (Maze& maze)
{
	stack<Point> q;
	Point startPos = maze.startPosition();
	Point goalPos = maze.goalPosition();
		//mark startPos in the maze as distance 0
	maze.set(startPos.x, startPos.y, '@');
	q.push(startPos);
	while ((maze(goalPos.x,goalPos.y) == Maze::Goal) && (!q.empty()))
	{
		Point currentPos = q.top();
		q.pop();
		cout << "\n" << maze;
		cout << "Looking at " << currentPos << endl;
		char currentChar = maze(currentPos.x, currentPos.y);
		int currentDist = currentChar - '@';
		trickleInto (currentPos.x+1, currentPos.y, q, maze, currentDist);
		trickleInto (currentPos.x-1, currentPos.y, q, maze, currentDist);
		trickleInto (currentPos.x, currentPos.y-1, q, maze, currentDist);
		trickleInto (currentPos.x, currentPos.y+1, q, maze, currentDist);

	}
	if (maze(goalPos.x,goalPos.y) == Maze::Goal)
	{
		return -1;
	}
	else
	{
		return maze(goalPos.x, goalPos.y) - '@';
	}
}

void solveMaze (istream& in)
{
    Maze maze;
    in >> maze;
    int dist = findShortestPath(maze);
    cout << "Found a path in " << dist << " steps." << endl;
    cout << maze << flush;
}


int main(int nargs, char** args)
{
    if (nargs > 1)
    {
        ifstream in (args[1]);
        solveMaze(in);
    }
    else
        solveMaze(cin);
    return 0;
}
